;##################################################################
; MsgBoxHook
;##################################################################

#include MsgBoxHook.h

/*
#define DEBUGEXE "C:\Programming\RadASM3\GoAsm\dbg\DbgWin.exe"
#define PRESERVEXMMREGS
#define DBG64LIB "C:\Programming\RadASM3\GoAsm\dbg\Debug64.lib"
#define DBG32LIB "C:\Programming\RadASM3\GoAsm\dbg\Debug32.lib"
#IF X64
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug64.a"
#ELSE
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug32.a"
#ENDIF
*/

DATA SECTION
	hInstance			HANDLE ?
	hHook				HANDLE ?
	hBrush				HANDLE ?

CODE SECTION

START:

	invoke GetModuleHandle, NULL
	mov [hInstance],eax
	invoke CreateSolidBrush,0xFF0000
	mov [hBrush],eax
	invoke GetCurrentThreadId
	invoke SetWindowsHookEx, WH_CALLWNDPROC, offset MsgBoxHookProc,0,eax
	mov [hHook],eax
	invoke MessageBox,NULL,"Hello",0,0
	invoke DeleteObject,[hBrush]
	invoke ExitProcess,eax

MsgBoxHookProc FRAME nCode, wParam, lParam
	uses edi

	cmp D[nCode],HC_ACTION
	jne >>.NEXTHOOK
		mov edi,[lParam]
		cmp D[edi+CWPSTRUCT.message],WM_INITDIALOG
		jne >>
			invoke SetWindowSubclass,[edi+CWPSTRUCT.hwnd],offset MsgBoxSubClass,1,0
		:
	.NEXTHOOK
	invoke CallNextHookEx,[hHook],[nCode], [wParam], [lParam]
	ret
endf

MsgBoxSubClass FRAME hwnd,uMsg, wParam, lParam, uIdSubclass, dwRefData
	
	cmp D[uMsg],WM_CTLCOLORDLG
	jne >>
		mov eax,[hBrush]
		ret
	:
	cmp D[uMsg],WM_NCDESTROY
	jne >>.DEFPROC
		invoke UnhookWindowsHookEx,[hHook]
	.DEFPROC
	invoke DefSubclassProc, [hwnd], [uMsg], [wParam], [lParam]
	ret
endf